!
! *
! *  Elmer, A Finite Element Software for Multiphysical Problems
! *
! *  Copyright 1st April 1995 - , CSC - IT Center for Science Ltd., Finland
! * 
! *  This program is free software; you can redistribute it and/or
! *  modify it under the terms of the GNU General Public License
! *  as published by the Free Software Foundation; either version 2
! *  of the License, or (at your option) any later version.
! * 
! *  This program is distributed in the hope that it will be useful,
! *  but WITHOUT ANY WARRANTY; without even the implied warranty of
! *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! *  GNU General Public License for more details.
! *
! *  You should have received a copy of the GNU General Public License
! *  along with this program (in file fem/GPL-2); if not, write to the 
! *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
! *  Boston, MA 02110-1301, USA.
! *
! *****************************************************************************/
!
!

      SUBROUTINE SolveBandLapack( N,M,A,X,Subband,Band )

      USE Types
      IMPLICIT NONE
 

      INTEGER :: N,M,Subband,Band,i,j
      REAL(KIND=dp) :: A(Band,N),X(M,N)

      INTEGER :: IPIV(N),iINFO

      IF ( N .LE. 0 ) RETURN

      iINFO = 0
      CALL DGBTRF( N,N,Subband,Subband,A,Band,IPIV,iINFO )
      IF ( iinfo /= 0 ) THEN
         PRINT*,'ERROR: SolveBand: singular matrix. LAPACK DGBTRF info: ',iinfo
         STOP
      END IF

      iINFO = 0
      CALL DGBTRS( 'N',N,Subband,Subband,M,A,Band,IPIV,X,N,iINFO )
        IF ( iinfo /= 0 ) THEN
        PRINT*,'ERROR: SolveBand: singular matrix. LAPACK DGBTRS info: ',iinfo
          STOP
        END IF

      END


      SUBROUTINE SolveComplexBandLapack( N,M,A,X,Subband,Band )

      USE Types
      IMPLICIT NONE

      INTEGER :: N,M,Subband,Band,i,j
      COMPLEX(KIND=dp) :: A(Band,N),X(M,N)

      INTEGER :: IPIV(N),iINFO

      IF ( N .LE. 0 ) RETURN

      iINFO = 0
      CALL ZGBTRF( N,N,Subband,Subband,A,Band,IPIV,iINFO )
        IF ( iinfo /= 0 ) THEN
        PRINT*,'ERROR: SolveBand: singular matrix. LAPACK ZGBTRF info: ',iinfo
          STOP
        END IF

      iINFO = 0
      CALL ZGBTRS( 'N',N,Subband,Subband,M,A,Band,IPIV,X,N,iINFO )
        IF ( iinfo /= 0 ) THEN
        PRINT*,'ERROR: SolveBand: singular matrix. LAPACK ZGBTRS info: ',iinfo
          STOP
        END IF

      END
